package anywheresoftware.b4a.samples.listview;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    private static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.listview", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.listview", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
		processBA.raiseEvent(_activity, "activity_pause", activityBA.activity.isFinishing());
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
	
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
public anywheresoftware.b4a.phone.Phone _phone1 = null;
public anywheresoftware.b4a.objects.collections.List _iconlist = null;
public static long _i = 0L;
public static String  _activity_create(boolean _firsttime) throws Exception{
 BA.debugLineNum = 10;BA.debugLine="Activity.Title = \"Andoid System Icons - Requio, Okinawa\"";
mostCurrent._activity.setTitle((Object)("Andoid System Icons - Requio, Okinawa"));
 BA.debugLineNum = 11;BA.debugLine="ImageView1.Initialize(\"ImageView1\")";
mostCurrent._imageview1.Initialize(mostCurrent.activityBA,"ImageView1");
 BA.debugLineNum = 12;BA.debugLine="ImageView1.Gravity = Gravity.FILL";
mostCurrent._imageview1.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.FILL);
 BA.debugLineNum = 13;BA.debugLine="IconList.Initialize";
mostCurrent._iconlist.Initialize();
 BA.debugLineNum = 14;BA.debugLine="IconList = File.ReadList(File.DirAssets,\"codenames.txt\")";
mostCurrent._iconlist = anywheresoftware.b4a.keywords.Common.File.ReadList(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"codenames.txt");
 BA.debugLineNum = 15;BA.debugLine="ListView1.Initialize(\"ListView1\")";
mostCurrent._listview1.Initialize(mostCurrent.activityBA,"ListView1");
 BA.debugLineNum = 16;BA.debugLine="Activity.AddView(ImageView1, 0, 0, 48dip, 48dip)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._imageview1.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(48)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(48)));
 BA.debugLineNum = 17;BA.debugLine="Activity.AddView(ListView1, 0, 60dip, 100%x, 80%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._listview1.getObject()),(int)(0),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(60)),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(80),mostCurrent.activityBA));
 BA.debugLineNum = 18;BA.debugLine="ListView1.FastScrollEnabled = True";
mostCurrent._listview1.setFastScrollEnabled(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 19;BA.debugLine="ListView1.TwoLinesAndBitmap.ItemHeight = 55dip";
mostCurrent._listview1.getTwoLinesAndBitmap().setItemHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(55)));
 BA.debugLineNum = 20;BA.debugLine="ListView1.TwoLinesAndBitmap.Label.TextSize = 16";
mostCurrent._listview1.getTwoLinesAndBitmap().Label.setTextSize((float)(16));
 BA.debugLineNum = 21;BA.debugLine="ListView1.TwoLinesAndBitmap.SecondLabel.TextSize = 16";
mostCurrent._listview1.getTwoLinesAndBitmap().SecondLabel.setTextSize((float)(16));
 BA.debugLineNum = 22;BA.debugLine="ListView1.TwoLinesAndBitmap.SecondLabel.TextColor = Colors.RGB(255,60,0)";
mostCurrent._listview1.getTwoLinesAndBitmap().SecondLabel.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(60),(int)(0)));
 BA.debugLineNum = 23;BA.debugLine="ListView1.TwoLinesAndBitmap.Label.Gravity = Gravity.CENTER_VERTICAL";
mostCurrent._listview1.getTwoLinesAndBitmap().Label.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL);
 BA.debugLineNum = 24;BA.debugLine="ListView1.TwoLinesAndBitmap.SecondLabel.Gravity = Gravity.TOP";
mostCurrent._listview1.getTwoLinesAndBitmap().SecondLabel.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.TOP);
 BA.debugLineNum = 25;BA.debugLine="ListView1.TwoLinesAndBitmap.ImageView.Width = 48dip";
mostCurrent._listview1.getTwoLinesAndBitmap().ImageView.setWidth(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(48)));
 BA.debugLineNum = 26;BA.debugLine="ListView1.TwoLinesAndBitmap.ImageView.Height = 48dip";
mostCurrent._listview1.getTwoLinesAndBitmap().ImageView.setHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(48)));
 BA.debugLineNum = 27;BA.debugLine="ListView1.TwoLinesAndBitmap.ImageView.Gravity = Gravity.FILL";
mostCurrent._listview1.getTwoLinesAndBitmap().ImageView.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.FILL);
 BA.debugLineNum = 28;BA.debugLine="For i = 17301504 To 17301683";
{
final double step26 = 1;
final double limit26 = (long)(17301683);
for (_i = (long)(17301504); (step26 > 0 && _i <= limit26) || (step26 < 0 && _i >= limit26); _i += step26) {
 BA.debugLineNum = 29;BA.debugLine="If i <> 17301679 Then 'constant value 17301679 throws an error on Sharp IS03";
if (_i!=(long)(17301679)) { 
 BA.debugLineNum = 30;BA.debugLine="ImageView1.Background = Phone1.GetResourceDrawable(i)";
mostCurrent._imageview1.setBackground(mostCurrent._phone1.GetResourceDrawable((int)(_i)));
 BA.debugLineNum = 31;BA.debugLine="ListView1.AddTwoLinesAndBitmap2(IconList.Get(i - 17301504),i,ImageView1.Bitmap,i)";
mostCurrent._listview1.AddTwoLinesAndBitmap2(String.valueOf(mostCurrent._iconlist.Get((int)(_i-17301504))),BA.NumberToString(_i),mostCurrent._imageview1.getBitmap(),(Object)(_i));
 BA.debugLineNum = 32;BA.debugLine="End If";
};
 BA.debugLineNum = 33;BA.debugLine="Next";
}
};
 BA.debugLineNum = 34;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 BA.debugLineNum = 2;BA.debugLine="Dim ListView1 As ListView";
mostCurrent._listview1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 BA.debugLineNum = 3;BA.debugLine="Dim ImageView1 As ImageView";
mostCurrent._imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 BA.debugLineNum = 4;BA.debugLine="Dim Phone1 As Phone";
mostCurrent._phone1 = new anywheresoftware.b4a.phone.Phone();
 BA.debugLineNum = 5;BA.debugLine="Dim IconList As List";
mostCurrent._iconlist = new anywheresoftware.b4a.objects.collections.List();
 BA.debugLineNum = 6;BA.debugLine="Dim i As Long";
_i = 0L;
 BA.debugLineNum = 7;BA.debugLine="End Sub";
return "";
}
public static String  _listview1_itemclick(int _position,Object _value) throws Exception{
 BA.debugLineNum = 37;BA.debugLine="ImageView1.Background = Phone1.GetResourceDrawable(Value)";
mostCurrent._imageview1.setBackground(mostCurrent._phone1.GetResourceDrawable((int)(BA.ObjectToNumber(_value))));
 BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
}
